<template>
  <li
    v-if="canViewVerticalNavMenuGroup(item)"
    class="nav-item has-sub"
    :class="{
      open: isOpen,
      'sidebar-group-active': isActive,
    }"
  >
    <b-link
      class="d-flex align-items-center"
      @click="() => updateGroupOpen(!isOpen)"
    >
      <!-- <feather-icon :icon="item.icon || 'CircleIcon'" /> -->
      <span class="menu-title text-truncate">{{ item.name }}</span>
    </b-link>

    <b-collapse v-model="isOpen" class="menu-content" tag="ul">
      <component
        :is="resolveNavItemComponent(child)"
        v-for="child in item.children"
        :key="child.header || child.title"
        ref="groupChild"
        :item="child"
      />
    </b-collapse>
  </li>
</template>

<script>
import { BCollapse, BLink } from "bootstrap-vue";
import { ref } from "@vue/composition-api";

export default {
  name: "VerticalNavMenuGroup",
  components: {
    BCollapse,
    BLink,
  },
  props: {
    item: {
      type: Object,
      required: true,
    },
  },
  setup() {
    const items = [
      {
        id: 1,
        name: "Applications :",
        locked: true,
        children: [
          { id: 2, name: "Calendar : app" },
          { id: 3, name: "Chrome : app" },
          { id: 4, name: "Webstorm : app" },
        ],
      },
      {
        id: 5,
        name: "Documents :",
        children: [
          {
            id: 6,
            name: "vuetify :",
            children: [
              {
                id: 7,
                name: "src :",
                locked: true,
                children: [
                  { id: 8, name: "index : ts" },
                  { id: 9, name: "bootstrap : ts" },
                ],
              },
            ],
          },
          {
            id: 10,
            name: "material2 :",
            children: [
              {
                id: 11,
                name: "src :",
                children: [
                  { id: 12, name: "v-btn : ts" },
                  { id: 13, name: "v-card : ts" },
                  { id: 14, name: "v-window : ts" },
                ],
              },
            ],
          },
        ],
      },
      {
        id: 15,
        name: "Downloads :",
        children: [
          { id: 16, name: "October : pdf", locked: true },
          { id: 17, name: "November : pdf", locked: true },
          { id: 18, name: "Tutorial : html", locked: true },
        ],
      },
      {
        id: 19,
        name: "Videos :",
        children: [
          {
            id: 20,
            name: "Tutorials :",
            children: [
              { id: 21, name: "Basic layouts : mp4" },
              { id: 22, name: "Advanced techniques : mp4" },
              { id: 23, name: "All about app : dir" },
            ],
          },
          { id: 24, name: "Intro : mov" },
          { id: 25, name: "Conference introduction : avi" },
        ],
      },
    ];

    const isOpen = ref(false);

    const isActive = ref(false);

    const resolveNavItemComponent = (child) => {
      console.log(child);
      return "VerticalNavMenuGroup";
    };

    const canViewVerticalNavMenuGroup = (asd) => {
      console.log(asd);
      return true;
    };

    const updateGroupOpen = (value) => {
      isOpen.value = value;
    };

    return {
      items,
      isOpen,
      isActive,
      canViewVerticalNavMenuGroup,
      updateGroupOpen,
      resolveNavItemComponent,
    };
  },
};
</script>